﻿using System;
using Telerik.WinControls.UI;

namespace RadPropertyGridCustomItemElement
{
    public partial class Form1 : RadForm
    {
        public Form1()
        {
            InitializeComponent();

            this.Size = new System.Drawing.Size(500, 200);
            this.radPropertyGrid1.SelectedObject = new DemoClass("Text");
            this.radPropertyGrid1.Dock = System.Windows.Forms.DockStyle.Left;
            this.radPropertyGrid1.CreateItemElement += new CreatePropertyGridItemElementEventHandler(radPropertyGrid1_CreateItemElement);
            this.radPropertyGrid1.Editing += new PropertyGridItemEditingEventHandler(radPropertyGrid1_Editing);
            this.radPropertyGrid1.EditorRequired += radPropertyGrid1_EditorRequired; 
            this.radPropertyGrid1.EditorInitialized += radPropertyGrid1_EditorInitialized;
        }

        private void radPropertyGrid1_EditorInitialized(object sender, PropertyGridItemEditorInitializedEventArgs e)
        {
            PropertyGridBrowseEditor browseEditor = e.Editor as PropertyGridBrowseEditor;
            if (browseEditor != null)
            {
                RadBrowseEditorElement el = browseEditor.EditorElement as RadBrowseEditorElement;
                el.ReadOnly = false;
            }
        }

        private void radPropertyGrid1_EditorRequired(object sender, PropertyGridEditorRequiredEventArgs e)
        {
            if (e.Item.Name == "SpecialText14")
            {
                e.EditorType = typeof(CustomPropertyGridBrowseEditor);
            }
        }

        private void radPropertyGrid1_Editing(object sender, PropertyGridItemEditingEventArgs e)
        {
            if (e.Item.Name == "SpecialText14" && e.Item.Tag == "CancelEdit")
            {
                e.Cancel = true;
            }
        }

        private void radPropertyGrid1_CreateItemElement(object sender, CreatePropertyGridItemElementEventArgs e)
        {
            if (e.Item.Name == "SpecialText14")
            {
                e.ItemElementType = typeof(CustomPropertyGridItemElement);
            }
            else
            {
                e.ItemElementType = typeof(StandardItem);
            }
        }

        public class CustomPropertyGridBrowseEditor : PropertyGridBrowseEditor
        {
            protected override Telerik.WinControls.RadElement CreateEditorElement()
            {
                return new CustomRadBrowseEditorElement();
            }
        }

        public class CustomRadBrowseEditorElement : RadBrowseEditorElement
        {
            protected override Type ThemeEffectiveType
            {
                get
                {
                    return typeof(RadBrowseEditorElement);
                }
            }

            protected override void OnBrowseButtonClick(EventArgs e)
            {
                //implement your custom logic.
                base.OnBrowseButtonClick(e);
            }
        }
    }
}